## qjackctl 0.9.0

=== CMakeLists.txt ===
project(qjackctl)

cmake_minimum_required(VERSION 3.1)

set (VERSION "0.9.0")

set (CONFIG_VERSION ${VERSION})
execute_process (
  COMMAND git describe --tags --dirty --abbrev=6
  OUTPUT_VARIABLE GIT_DESCRIBE_OUTPUT
  RESULT_VARIABLE GIT_DESCRIBE_RESULT
  OUTPUT_STRIP_TRAILING_WHITESPACE)
if (GIT_DESCRIBE_RESULT EQUAL 0)
  set (VERSION "${GIT_DESCRIBE_OUTPUT}")
  string (REGEX REPLACE "^[^0-9]+" "" VERSION "${VERSION}")
  string (REGEX REPLACE "-g"   "git." VERSION "${VERSION}")
  string (REGEX REPLACE "[_|-]+"  "." VERSION "${VERSION}")
  execute_process (
    COMMAND git rev-parse --abbrev-ref HEAD
    OUTPUT_VARIABLE GIT_REVPARSE_OUTPUT
    RESULT_VARIABLE GIT_REVPARSE_RESULT
    OUTPUT_STRIP_TRAILING_WHITESPACE)
  if (GIT_REVPARSE_RESULT EQUAL 0 AND NOT GIT_REVPARSE_OUTPUT STREQUAL "master")
    set (VERSION "${VERSION} [${GIT_REVPARSE_OUTPUT}]")
  endif ()
endif ()

set (PACKAGE_NAME "QjackCtl")
set (PACKAGE_VERSION "${VERSION}")
set (PACKAGE_BUGREPORT "rncbc@rncbc.org")
set (PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")
set (PACKAGE_TARNAME "qjackctl")

set (CONFIG_BUILD_VERSION "${PACKAGE_VERSION}")

if (CMAKE_BUILD_TYPE)
  set (CONFIG_BUILD_TYPE ${CMAKE_BUILD_TYPE})
else ()
  set (CONFIG_BUILD_TYPE "release")
endif ()

set (CONFIG_DEBUG 0)
if (CONFIG_BUILD_TYPE MATCHES "debug")
  set (CONFIG_DEBUG 1)
endif ()

set (CONFIG_PREFIX "${CMAKE_INSTALL_PREFIX}")

include (GNUInstallDirs)
set (CONFIG_BINDIR  "${CONFIG_PREFIX}/${CMAKE_INSTALL_BINDIR}")
set (CONFIG_LIBDIR  "${CONFIG_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
set (CONFIG_DATADIR "${CONFIG_PREFIX}/${CMAKE_INSTALL_DATADIR}")
set (CONFIG_MANDIR  "${CONFIG_PREFIX}/${CMAKE_INSTALL_MANDIR}")


# Disable system tray argument option.
option (CONFIG_SYSTEM_TRAY "Enable system tray (default=yes)" 1)

# Enable JACK session support.
option (CONFIG_JACK_SESSION "Enable JACK session support (default=yes)" 1)

# Enable JACK port aliases support.
option (CONFIG_JACK_PORT_ALIASES "Enable JACK port aliases support (default=yes)" 1)

# Enable JACK metadata support.
option (CONFIG_JACK_METADATA "Enable JACK metadata support (default=yes)" 1)

# Enable JACK MIDI support option.
option (CONFIG_JACK_MIDI "Enable JACK MIDI support (default=yes)" 1)

# Enable JACK CV support option.
option (CONFIG_JACK_CV "Enable JACK CV support (default=yes)" 1)

# Enable JACK OSC support option.
option (CONFIG_JACK_OSC "Enable JACK OSC support (default=yes)" 1)

# Enable JACK version support.
option (CONFIG_JACK_VERSION "Enable JACK version support (default=no)" 0)

# Enable ALSA sequencer support option.
option (CONFIG_ALSA_SEQ "Enable ALSA/MIDI sequencer support (default=yes)" 1)

# Enable PortAudio argument option.
option (CONFIG_PORTAUDIO "Enable PortAudio interface (default=yes)" 1)

# Enable D-Bus argument option.
option (CONFIG_DBUS "Enable D-Bus interface (default=yes)" 1)

# Enable unique/single instance.
option (CONFIG_XUNIQUE "Enable unique/single instance (default=yes)" 1)

# Enable debugger stack-trace option (assumes --enable-debug).
option (CONFIG_STACKTRACE "Enable debugger stack-trace (default=no)" 0)


# Fix for new CMAKE_REQUIRED_LIBRARIES policy.
if (POLICY CMP0075)
  cmake_policy (SET CMP0075 NEW)
endif ()

# Check for Qt
find_package (QT NAMES Qt6 Qt5 COMPONENTS Core REQUIRED)
find_package (Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui Widgets Xml)

if (CONFIG_XUNIQUE)
  find_package (Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Network)
endif ()

if (CONFIG_DBUS)
  find_package (Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS DBus)
endif ()

find_package (Qt${QT_VERSION_MAJOR}LinguistTools)

include (CheckIncludeFile)
include (CheckIncludeFiles)
include (CheckIncludeFileCXX)
include (CheckFunctionExists)
include (CheckLibraryExists)


# Checks for header files.
if (UNIX AND NOT APPLE)
  check_include_files ("fcntl.h;unistd.h;signal.h" HAVE_SIGNAL_H)
endif ()


# Find package modules
find_package (PkgConfig REQUIRED)

# Check for JACK libraries.
pkg_check_modules (JACK REQUIRED jack>=0.100.0)
if (JACK_FOUND)
  set (CONFIG_JACK 1)
  include_directories (${JACK_INCLUDE_DIRS})
  link_directories (${JACK_LIBRARY_DIRS})
# link_libraries (${JACK_LIBRARIES})
  set (CMAKE_REQUIRED_LIBRARIES "${JACK_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
  # Check for jack/statistics.h header.
  check_include_file (jack/statistics.h HAVE_JACK_STATISTICS_H)
  if (NOT HAVE_JACK_STATISTICS_H)
    set (CONFIG_JACK_STATISTICS 0)
  else ()
    set (CONFIG_JACK_STATISTICS 1)
  endif ()
  # Check for JACK MIDI headers availability.
  if (CONFIG_JACK_MIDI)
    check_include_file (jack/midiport.h HAVE_JACK_MIDIPORT_H)
    if (NOT HAVE_JACK_MIDIPORT_H)
      set (CONFIG_JACK_MIDI 0)
    endif ()
  endif ()
  # Check for JACK session headers availability.
  if (CONFIG_JACK_SESSION)
    check_include_file (jack/session.h HAVE_JACK_SESSION_H)
    if (NOT HAVE_JACK_SESSION_H)
      set (CONFIG_JACK_SESSION 0)
    endif ()
  endif ()
  # Check for JACK metadata headers availability.
  if (CONFIG_JACK_METADATA)
    check_include_file (jack/metadata.h HAVE_JACK_METADATA_H)
    if (NOT HAVE_JACK_METADATA_H)
      set (CONFIG_JACK_METADATA 0)
    endif ()
  endif ()
  if (NOT CONFIG_JACK_METADATA)
      set (CONFIG_JACK_CV  0)
      set (CONFIG_JACK_OSC 0)
  endif ()
  # Check for jack_transport_query function.
  check_function_exists (jack_transport_query CONFIG_JACK_TRANSPORT)
  # Check for jack_is_realtime function.
  check_function_exists (jack_is_realtime CONFIG_JACK_REALTIME)
  # Check for jack_get_xrun_delayed_usecs function.
  check_function_exists (jack_get_xrun_delayed_usecs CONFIG_JACK_XRUN_DELAY)
  # Check for jack_get_max_delayed_usecs function.
  check_function_exists (jack_get_max_delayed_usecs CONFIG_JACK_MAX_DELAY)
  # Check for jack_set_port_rename_callback
  check_function_exists (jack_set_port_rename_callback CONFIG_JACK_PORT_RENAME)
  # Check for jack_port_get_aliases function.
  if (CONFIG_JACK_PORT_ALIASES)
    check_function_exists (jack_port_get_aliases CONFIG_JACK_PORT_ALIASES)
  endif ()
  # Check for jack_get_version_string function.
  if (CONFIG_JACK_VERSION)
    check_function_exists (jack_get_version_string CONFIG_JACK_VERSION)
  endif ()
  # Check for jack_free function.
  check_function_exists (jack_free CONFIG_JACK_FREE)
else ()
  message (FATAL_ERROR "*** JACK library not found.")
  set (CONFIG_JACK 0)
endif ()

# Check for ALSA libraries.
if (CONFIG_ALSA_SEQ)
  pkg_check_modules (ALSA alsa)
  if (ALSA_FOUND)
    include_directories (${ALSA_INCLUDE_DIRS})
    link_directories (${ALSA_LIBRARY_DIRS})
    link_libraries (${ALSA_LIBRARIES})
  # set (CMAKE_REQUIRED_LIBRARIES "${ALSA_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
  else ()
    message (WARNING "*** ALSA library not found.")
    set (CONFIG_ALSA_SEQ 0)
  endif ()
endif ()

# Check for PORTAUDIO libraries.
if (CONFIG_PORTAUDIO)
  pkg_check_modules (PORTAUDIO portaudio-2.0)
  if (PORTAUDIO_FOUND)
    include_directories (${PORTAUDIO_INCLUDE_DIRS})
    link_directories (${PORTAUDIO_LIBRARY_DIRS})
    link_libraries (${PORTAUDIO_LIBRARIES})
  # set (CMAKE_REQUIRED_LIBRARIES "${PORTAUDIO_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
  else ()
    message (WARNING "*** PORTAUDIO library not found.")
    set (CONFIG_PORTAUDIO 0)
  endif ()
endif ()


if (APPLE AND CONFIG_COREAUDIO)
  check_include_file (CoreAudio/CoreAudio.h HAVE_COREAUDIO_H)
  if (NOT HAVE_COREAUDIO_H)
    set (CONFIG_COREAUDIO 0)
  endif ()
endif ()


add_subdirectory (src)

configure_file (qjackctl.spec.in qjackctl.spec IMMEDIATE @ONLY)

install (FILES qjackctl.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
install (FILES qjackctl.fr.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/fr/man1 RENAME qjackctl.1)

# Configuration status
macro (SHOW_OPTION text value)
  if (${value})
    message ("${text}: yes")
  else ()
    message ("${text}: no")
  endif ()
endmacro ()


message   ("\n  ${PACKAGE_NAME} ${PACKAGE_VERSION}")
message   ("\n  Build target . . . . . . . . . . . . . . . . . . .: ${CONFIG_BUILD_TYPE}\n")
show_option ("  JACK Audio Connection Kit support  . . . . . . . ." CONFIG_JACK)
show_option ("  JACK Realtime support  . . . . . . . . . . . . . ." CONFIG_JACK_REALTIME)
show_option ("  JACK Transport support . . . . . . . . . . . . . ." CONFIG_JACK_TRANSPORT)
show_option ("  JACK XRUN delay support  . . . . . . . . . . . . ." CONFIG_JACK_XRUN_DELAY)
show_option ("  JACK Maximum scheduling delay support  . . . . . ." CONFIG_JACK_MAX_DELAY)
show_option ("  JACK Port aliases support  . . . . . . . . . . . ." CONFIG_JACK_PORT_ALIASES)
show_option ("  JACK Metadata support  . . . . . . . . . . . . . ." CONFIG_JACK_METADATA)
show_option ("  JACK MIDI support  . . . . . . . . . . . . . . . ." CONFIG_JACK_MIDI)
show_option ("  JACK CV support  . . . . . . . . . . . . . . . . ." CONFIG_JACK_CV)
show_option ("  JACK OSC support . . . . . . . . . . . . . . . . ." CONFIG_JACK_OSC)
show_option ("  JACK Session support . . . . . . . . . . . . . . ." CONFIG_JACK_SESSION)
show_option ("  JACK Version support (JACK2) . . . . . . . . . . ." CONFIG_JACK_VERSION)
show_option ("  ALSA MIDI Sequencer support  . . . . . . . . . . ." CONFIG_ALSA_SEQ)
show_option ("  System tray icon support . . . . . . . . . . . . ." CONFIG_SYSTEM_TRAY)
show_option ("  D-Bus interface support  . . . . . . . . . . . . ." CONFIG_DBUS)
show_option ("  PortAudio interface support  . . . . . . . . . . ." CONFIG_PORTAUDIO)
show_option ("  CoreAudio interface support  . . . . . . . . . . ." CONFIG_COREAUDIO)
message     ("")
show_option ("  System tray icon support . . . . . . . . . . . . ." CONFIG_SYSTEM_TRAY)
show_option ("  Unique/Single instance support . . . . . . . . . ." CONFIG_XUNIQUE)
show_option ("  Debugger stack-trace (gdb) . . . . . . . . . . . ." CONFIG_STACKTRACE)
message   ("\n  Install prefix . . . . . . . . . . . . . . . . . .: ${CMAKE_INSTALL_PREFIX}")
message   ("\nNow type 'make', followed by 'make install' as root.\n")

=== src/CMakeLists.txt ===
# project(qjackctl)

include_directories (
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
)

configure_file (cmake_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)

set (HEADERS
  qjackctl.h
  qjackctlAbout.h
  qjackctlAlsaConnect.h
  qjackctlAlsaGraph.h
  qjackctlConnect.h
  qjackctlAliases.h
  qjackctlGraph.h
  qjackctlGraphCommand.h
  qjackctlInterfaceComboBox.h
  qjackctlJackConnect.h
  qjackctlJackGraph.h
  qjackctlPatchbay.h
  qjackctlPatchbayFile.h
  qjackctlPatchbayRack.h
  qjackctlSession.h
  qjackctlSetup.h
  qjackctlStatus.h
  qjackctlSystemTray.h
  qjackctlAboutForm.h
  qjackctlConnectionsForm.h
  qjackctlGraphForm.h
  qjackctlMainForm.h
  qjackctlMessagesStatusForm.h
  qjackctlPatchbayForm.h
  qjackctlSessionForm.h
  qjackctlSetupForm.h
  qjackctlPaletteForm.h
  qjackctlSocketForm.h
)

set (SOURCES
  qjackctl.cpp
  qjackctlAlsaConnect.cpp
  qjackctlAlsaGraph.cpp
  qjackctlConnect.cpp
  qjackctlAliases.cpp
  qjackctlGraph.cpp
  qjackctlGraphCommand.cpp
  qjackctlInterfaceComboBox.cpp
  qjackctlJackConnect.cpp
  qjackctlJackGraph.cpp
  qjackctlPatchbay.cpp
  qjackctlPatchbayFile.cpp
  qjackctlPatchbayRack.cpp
  qjackctlSession.cpp
  qjackctlSetup.cpp
  qjackctlSystemTray.cpp
  qjackctlAboutForm.cpp
  qjackctlConnectionsForm.cpp
  qjackctlGraphForm.cpp
  qjackctlMainForm.cpp
  qjackctlMessagesStatusForm.cpp
  qjackctlPatchbayForm.cpp
  qjackctlSessionForm.cpp
  qjackctlSetupForm.cpp
  qjackctlPaletteForm.cpp
  qjackctlSocketForm.cpp
)

set (FORMS
  qjackctlAboutForm.ui
  qjackctlConnectionsForm.ui
  qjackctlGraphForm.ui
  qjackctlMainForm.ui
  qjackctlMessagesStatusForm.ui
  qjackctlPatchbayForm.ui
  qjackctlSessionForm.ui
  qjackctlSetupForm.ui
  qjackctlPaletteForm.ui
  qjackctlSocketForm.ui
)

set (RESOURCES
  qjackctl.qrc
)

set (TRANSLATIONS
	translations/qjackctl_cs.ts
	translations/qjackctl_de.ts
	translations/qjackctl_es.ts
	translations/qjackctl_fr.ts
	translations/qjackctl_it.ts
	translations/qjackctl_ja.ts
	translations/qjackctl_nl.ts
	translations/qjackctl_pt.ts
	translations/qjackctl_ru.ts
	translations/qjackctl_sk.ts
	translations/qjackctl_uk.ts
)

qt_wrap_ui (UI_SOURCES ${FORMS})
qt_wrap_cpp (MOC_SOURCES ${HEADERS})
qt_add_resources (QRC_SOURCES ${RESOURCES})
qt_add_translation (QM_FILES ${TRANSLATIONS})

add_custom_target (translations ALL DEPENDS ${QM_FILES})

if (WIN32)
  set (RC_FILE ${CMAKE_CURRENT_SOURCE_DIR}/win32/${PROJECT_NAME}.rc)
  set (RES_FILE ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.res.obj)
  find_program (WINDRES_EXECUTABLE NAMES windres mingw32-windres i686-mingw32-windres)
  if (MINGW)
    exec_program (${WINDRES_EXECUTABLE}
      ARGS "-i ${RC_FILE} -o ${RES_FILE} --include-dir=${CMAKE_CURRENT_SOURCE_DIR}/images")
    list (APPEND SOURCES ${RES_FILE})
  else ()
    list (APPEND SOURCES ${RC_FILE})
  endif ()
endif ()

if (APPLE)
  set (ICON_FILE ${CMAKE_CURRENT_SOURCE_DIR}/images/${PROJECT_NAME}.icns)
  list (APPEND SOURCES ${ICON_FILE})
  set (MACOSX_BUNDLE_ICON_FILE ${PROJECT_NAME}.icns)
  set_source_files_properties (${ICON_FILE} PROPERTIES
    MACOSX_PACKAGE_LOCATION Resources)
endif ()


add_executable (${PROJECT_NAME}
  ${UI_SOURCES}
  ${MOC_SOURCES}
  ${QRC_SOURCES}
  ${SOURCES}
)

set_target_properties (${PROJECT_NAME} PROPERTIES CXX_STANDARD 17)

if (WIN32)
  set_target_properties (${PROJECT_NAME} PROPERTIES WIN32_EXECUTABLE true)
endif ()

if (APPLE)
  set_target_properties (${PROJECT_NAME} PROPERTIES MACOSX_BUNDLE true)
endif ()

target_link_libraries (${PROJECT_NAME} PRIVATE Qt${QT_VERSION_MAJOR}::Widgets Qt${QT_VERSION_MAJOR}::Xml)

if (CONFIG_XUNIQUE)
  target_link_libraries (${PROJECT_NAME} PRIVATE Qt${QT_VERSION_MAJOR}::Network)
endif ()

if (CONFIG_DBUS)
  target_link_libraries (${PROJECT_NAME} PRIVATE Qt${QT_VERSION_MAJOR}::DBus)
endif ()

if (CONFIG_JACK)
  target_link_libraries (${PROJECT_NAME} PRIVATE ${JACK_LIBRARIES})
endif ()

if (CONFIG_ALSA_SEQ)
  target_link_libraries (${PROJECT_NAME} PRIVATE ${ALSA_LIBRARIES})
endif ()

if (CONFIG_PORTAUDIO)
  target_link_libraries (${PROJECT_NAME} PRIVATE ${PORTAUDIO_LIBRARIES})
endif ()


if (UNIX AND NOT APPLE)
  install (TARGETS ${PROJECT_NAME} RUNTIME
     DESTINATION ${CMAKE_INSTALL_BINDIR})
  install (FILES ${QM_FILES}
     DESTINATION ${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME}/translations)
  install (FILES ${PROJECT_NAME}.desktop
     DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
  install (FILES images/${PROJECT_NAME}.png
     DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/32x32/apps)
  install (FILES images/${PROJECT_NAME}.svg
     DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
  install (FILES appdata/${PROJECT_NAME}.appdata.xml
     DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)
endif ()

if (WIN32)
   install (TARGETS ${PROJECT_NAME} RUNTIME
     DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
   install (FILES ${QM_FILES}
     DESTINATION ${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME}/translations)
endif ()

=== debian/changelog ===
qjackctl (0.9.0-1~mx19+1) mx; urgency=medium

  * Initial packaging of upstream release for MX 19.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Fri, 15 Jan 2021 13:58:37 -0500

qjackctl (0.9.0-1) unstable; urgency=medium

  * New upstream version 0.9.0
  * Bump S-V to 4.5.1, no changes needed
  * d/rules: Remove override_dh_installman, applied by upstream
  * Bump d/watch version to 4

 -- Dennis Braun <d_braun@kabelmail.de>  Fri, 18 Dec 2020 22:31:55 +0100

=== debian/control ===
Source: qjackctl
Section: sound
Priority: optional
Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Dennis Braun <d_braun@kabelmail.de>,
 Adrian Knoth <adi@drcomp.erfurt.thur.de>,
 Jaromír Mikeš <mira.mikes@seznam.cz>,
 Free Ekanayaka <freee@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 libasound2-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386],
 libjack-dev,
 qtbase5-dev,
 qttools5-dev-tools,
 libqt5x11extras5-dev,
 libx11-dev
Standards-Version: 4.5.1
Homepage: https://qjackctl.sourceforge.io
Vcs-Git: https://salsa.debian.org/multimedia-team/qjackctl.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/qjackctl
Rules-Requires-Root: no

Package: qjackctl
Architecture: any
Depends:
 jackd,
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 pulseaudio-utils
Description: User interface for controlling the JACK sound server
 Qjackctl offers a user interface for controlling the JACK sound server
 daemon. At the same time it figures as a JACK patch bay and monitoring
 tool.

## qjackctl 0.9.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,11 @@
-project(qjackctl)
-
-cmake_minimum_required(VERSION 3.1)
-
-set (VERSION "0.9.0")
-
-set (CONFIG_VERSION ${VERSION})
+cmake_minimum_required(VERSION 3.10)
+
+project(qjackctl
+  VERSION 0.9.1
+  DESCRIPTION "JACK Audio Connection Kit Qt GUI Interface"
+  LANGUAGES C CXX)
+
+set (CONFIG_VERSION ${PROJECT_VERSION})
 execute_process (
   COMMAND git describe --tags --dirty --abbrev=6
   OUTPUT_VARIABLE GIT_DESCRIBE_OUTPUT
@@ -23,6 +24,8 @@
   if (GIT_REVPARSE_RESULT EQUAL 0 AND NOT GIT_REVPARSE_OUTPUT STREQUAL "master")
     set (VERSION "${VERSION} [${GIT_REVPARSE_OUTPUT}]")
   endif ()
+else ()
+  set (VERSION "${PROJECT_VERSION}")
 endif ()
 
 set (PACKAGE_NAME "QjackCtl")
@@ -129,7 +132,7 @@
 find_package (PkgConfig REQUIRED)
 
 # Check for JACK libraries.
-pkg_check_modules (JACK REQUIRED jack>=0.100.0)
+pkg_check_modules (JACK REQUIRED IMPORTED_TARGET jack>=0.100.0)
 if (JACK_FOUND)
   set (CONFIG_JACK 1)
   include_directories (${JACK_INCLUDE_DIRS})
@@ -195,7 +198,7 @@
 
 # Check for ALSA libraries.
 if (CONFIG_ALSA_SEQ)
-  pkg_check_modules (ALSA alsa)
+  pkg_check_modules (ALSA IMPORTED_TARGET alsa)
   if (ALSA_FOUND)
     include_directories (${ALSA_INCLUDE_DIRS})
     link_directories (${ALSA_LIBRARY_DIRS})
@@ -209,7 +212,7 @@
 
 # Check for PORTAUDIO libraries.
 if (CONFIG_PORTAUDIO)
-  pkg_check_modules (PORTAUDIO portaudio-2.0)
+  pkg_check_modules (PORTAUDIO IMPORTED_TARGET portaudio-2.0)
   if (PORTAUDIO_FOUND)
     include_directories (${PORTAUDIO_INCLUDE_DIRS})
     link_directories (${PORTAUDIO_LIBRARY_DIRS})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,14 @@
 # project(qjackctl)
 
-include_directories (
-  ${CMAKE_CURRENT_BINARY_DIR}
-  ${CMAKE_CURRENT_SOURCE_DIR}
-)
+set(CMAKE_INCLUDE_CURRENT_DIR ON)
 
+set(CMAKE_AUTOUIC ON)
+set(CMAKE_AUTOMOC ON)
+set(CMAKE_AUTORCC ON)
+
+if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
+    file(REMOVE ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
+endif()
 configure_file (cmake_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
 
 set (HEADERS
@@ -98,10 +102,11 @@
 	translations/qjackctl_uk.ts
 )
 
-qt_wrap_ui (UI_SOURCES ${FORMS})
-qt_wrap_cpp (MOC_SOURCES ${HEADERS})
-qt_add_resources (QRC_SOURCES ${RESOURCES})
-qt_add_translation (QM_FILES ${TRANSLATIONS})
+if (QT_VERSION VERSION_LESS 5.15.0)
+  qt5_add_translation (QM_FILES ${TRANSLATIONS})
+else ()
+  qt_add_translation (QM_FILES ${TRANSLATIONS})
+endif ()
 
 add_custom_target (translations ALL DEPENDS ${QM_FILES})
 
@@ -128,10 +133,10 @@
 
 
 add_executable (${PROJECT_NAME}
-  ${UI_SOURCES}
-  ${MOC_SOURCES}
-  ${QRC_SOURCES}
+  ${HEADERS}
   ${SOURCES}
+  ${FORMS}
+  ${RESOURCES}
 )
 
 set_target_properties (${PROJECT_NAME} PROPERTIES CXX_STANDARD 17)
@@ -155,15 +160,15 @@
 endif ()
 
 if (CONFIG_JACK)
-  target_link_libraries (${PROJECT_NAME} PRIVATE ${JACK_LIBRARIES})
+  target_link_libraries (${PROJECT_NAME} PRIVATE PkgConfig::JACK)
 endif ()
 
 if (CONFIG_ALSA_SEQ)
-  target_link_libraries (${PROJECT_NAME} PRIVATE ${ALSA_LIBRARIES})
+  target_link_libraries (${PROJECT_NAME} PRIVATE PkgConfig::ALSA)
 endif ()
 
 if (CONFIG_PORTAUDIO)
-  target_link_libraries (${PROJECT_NAME} PRIVATE ${PORTAUDIO_LIBRARIES})
+  target_link_libraries (${PROJECT_NAME} PRIVATE PkgConfig::PORTAUDIO)
 endif ()

=== debian/changelog ===
qjackctl (0.9.1-1) unstable; urgency=medium

  * New upstream version 0.9.1
  * Fix spelling error
  * Add d/lintian-overrides
  * Update d/copyright year

 -- Dennis Braun <d_braun@kabelmail.de>  Mon, 08 Feb 2021 18:22:27 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: qjackctl
 Section: sound
 Priority: optional
-Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Dennis Braun <d_braun@kabelmail.de>,
  Adrian Knoth <adi@drcomp.erfurt.thur.de>,

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_clean:
	dh_clean --exclude=qjackctl.pro

## qjackctl 0.9.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,23 +1,27 @@
-cmake_minimum_required(VERSION 3.10)
-
-project(qjackctl
-  VERSION 0.9.1
+cmake_minimum_required (VERSION 3.13)
+
+project (qjackctl
+  VERSION 0.9.4
   DESCRIPTION "JACK Audio Connection Kit Qt GUI Interface"
   LANGUAGES C CXX)
 
 set (CONFIG_VERSION ${PROJECT_VERSION})
 execute_process (
   COMMAND git describe --tags --dirty --abbrev=6
+  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
   OUTPUT_VARIABLE GIT_DESCRIBE_OUTPUT
   RESULT_VARIABLE GIT_DESCRIBE_RESULT
   OUTPUT_STRIP_TRAILING_WHITESPACE)
 if (GIT_DESCRIBE_RESULT EQUAL 0)
   set (VERSION "${GIT_DESCRIBE_OUTPUT}")
   string (REGEX REPLACE "^[^0-9]+" "" VERSION "${VERSION}")
+  string (REGEX REPLACE "^1_"      "" VERSION "${VERSION}")
+  string (REGEX REPLACE "^[_vV]+"  "" VERSION "${VERSION}")
   string (REGEX REPLACE "-g"   "git." VERSION "${VERSION}")
-  string (REGEX REPLACE "[_|-]+"  "." VERSION "${VERSION}")
+  string (REGEX REPLACE "[_|-]"   "." VERSION "${VERSION}")
   execute_process (
     COMMAND git rev-parse --abbrev-ref HEAD
+    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
     OUTPUT_VARIABLE GIT_REVPARSE_OUTPUT
     RESULT_VARIABLE GIT_REVPARSE_RESULT
     OUTPUT_STRIP_TRAILING_WHITESPACE)
@@ -34,17 +38,21 @@
 set (PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")
 set (PACKAGE_TARNAME "qjackctl")
 
+set (ac_version "${PROJECT_VERSION}")
+set (ac_prefix "${CMAKE_INSTALL_PREFIX}")
+
 set (CONFIG_BUILD_VERSION "${PACKAGE_VERSION}")
 
-if (CMAKE_BUILD_TYPE)
-  set (CONFIG_BUILD_TYPE ${CMAKE_BUILD_TYPE})
+if (CONFIG_DEBUG)
+  set (CMAKE_BUILD_TYPE "Debug")
+endif ()
+if (CMAKE_BUILD_TYPE MATCHES "Debug")
+  set (CONFIG_DEBUG 1)
+endif ()
+if (CONFIG_DEBUG)
+  set (CONFIG_BUILD_TYPE "debug")
 else ()
   set (CONFIG_BUILD_TYPE "release")
-endif ()
-
-set (CONFIG_DEBUG 0)
-if (CONFIG_BUILD_TYPE MATCHES "debug")
-  set (CONFIG_DEBUG 1)
 endif ()
 
 set (CONFIG_PREFIX "${CMAKE_INSTALL_PREFIX}")
@@ -96,13 +104,29 @@
 option (CONFIG_STACKTRACE "Enable debugger stack-trace (default=no)" 0)
 
 
+# Enable Qt6 build preference.
+option (CONFIG_QT6 "Enable Qt6 build (default=yes)" 1)
+
+
 # Fix for new CMAKE_REQUIRED_LIBRARIES policy.
 if (POLICY CMP0075)
   cmake_policy (SET CMP0075 NEW)
 endif ()
 
-# Check for Qt
-find_package (QT NAMES Qt6 Qt5 COMPONENTS Core REQUIRED)
+# Check for Qt...
+if (CONFIG_QT6)
+  find_package (Qt6 QUIET)
+  if (NOT Qt6_FOUND)
+    set (CONFIG_QT6 0)
+  endif ()
+endif ()
+
+if (CONFIG_QT6)
+  find_package (QT QUIET NAMES Qt6)
+else ()
+  find_package (QT QUIET NAMES Qt5)
+endif ()
+
 find_package (Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui Widgets Xml)
 
 if (CONFIG_XUNIQUE)
@@ -121,7 +145,6 @@
 include (CheckFunctionExists)
 include (CheckLibraryExists)
 
-
 # Checks for header files.
 if (UNIX AND NOT APPLE)
   check_include_files ("fcntl.h;unistd.h;signal.h" HAVE_SIGNAL_H)
@@ -129,16 +152,16 @@
 
 
 # Find package modules
-find_package (PkgConfig REQUIRED)
+include (FindPkgConfig)
 
 # Check for JACK libraries.
 pkg_check_modules (JACK REQUIRED IMPORTED_TARGET jack>=0.100.0)
 if (JACK_FOUND)
+  find_library(JACK_LIBRARY NAMES ${JACK_LIBRARIES} HINTS ${JACK_LIBDIR})
+endif ()
+if (JACK_LIBRARY)
   set (CONFIG_JACK 1)
-  include_directories (${JACK_INCLUDE_DIRS})
-  link_directories (${JACK_LIBRARY_DIRS})
-# link_libraries (${JACK_LIBRARIES})
-  set (CMAKE_REQUIRED_LIBRARIES "${JACK_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
+  set (CMAKE_REQUIRED_LIBRARIES "${JACK_LIBRARY};${CMAKE_REQUIRED_LIBRARIES}")
   # Check for jack/statistics.h header.
   check_include_file (jack/statistics.h HAVE_JACK_STATISTICS_H)
   if (NOT HAVE_JACK_STATISTICS_H)
@@ -200,10 +223,11 @@
 if (CONFIG_ALSA_SEQ)
   pkg_check_modules (ALSA IMPORTED_TARGET alsa)
   if (ALSA_FOUND)
-    include_directories (${ALSA_INCLUDE_DIRS})
-    link_directories (${ALSA_LIBRARY_DIRS})
-    link_libraries (${ALSA_LIBRARIES})
-  # set (CMAKE_REQUIRED_LIBRARIES "${ALSA_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
+    find_library(ALSA_LIBRARY NAMES ${ALSA_LIBRARIES} HINTS ${ALSA_LIBDIR})
+  endif ()
+  if (ALSA_LIBRARY)
+    set (CONFIG_ALSA_SEQ 1)
+    set (CMAKE_REQUIRED_LIBRARIES "${ALSA_LIBRARY};${CMAKE_REQUIRED_LIBRARIES}")
   else ()
     message (WARNING "*** ALSA library not found.")
     set (CONFIG_ALSA_SEQ 0)
@@ -214,10 +238,11 @@
 if (CONFIG_PORTAUDIO)
   pkg_check_modules (PORTAUDIO IMPORTED_TARGET portaudio-2.0)
   if (PORTAUDIO_FOUND)
-    include_directories (${PORTAUDIO_INCLUDE_DIRS})
-    link_directories (${PORTAUDIO_LIBRARY_DIRS})
-    link_libraries (${PORTAUDIO_LIBRARIES})
-  # set (CMAKE_REQUIRED_LIBRARIES "${PORTAUDIO_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
+    find_library(PORTAUDIO_LIBRARY NAMES ${PORTAUDIO_LIBRARIES} HINTS ${PORTAUDIO_LIBDIR})
+  endif ()
+  if (PORTAUDIO_LIBRARY)
+    set (CONFIG_PORTAUDIO 1)
+   #set (CMAKE_REQUIRED_LIBRARIES "${PORTAUDIO_LIBRARY};${CMAKE_REQUIRED_LIBRARIES}")
   else ()
     message (WARNING "*** PORTAUDIO library not found.")
     set (CONFIG_PORTAUDIO 0)
@@ -250,7 +275,7 @@
 endmacro ()
 
 
-message   ("\n  ${PACKAGE_NAME} ${PACKAGE_VERSION}")
+message   ("\n  ${PACKAGE_NAME} ${PACKAGE_VERSION} (Qt ${QT_VERSION})")
 message   ("\n  Build target . . . . . . . . . . . . . . . . . . .: ${CONFIG_BUILD_TYPE}\n")
 show_option ("  JACK Audio Connection Kit support  . . . . . . . ." CONFIG_JACK)
 show_option ("  JACK Realtime support  . . . . . . . . . . . . . ." CONFIG_JACK_REALTIME)
@@ -273,5 +298,5 @@
 show_option ("  System tray icon support . . . . . . . . . . . . ." CONFIG_SYSTEM_TRAY)
 show_option ("  Unique/Single instance support . . . . . . . . . ." CONFIG_XUNIQUE)
 show_option ("  Debugger stack-trace (gdb) . . . . . . . . . . . ." CONFIG_STACKTRACE)
-message   ("\n  Install prefix . . . . . . . . . . . . . . . . . .: ${CMAKE_INSTALL_PREFIX}")
+message   ("\n  Install prefix . . . . . . . . . . . . . . . . . .: ${CONFIG_PREFIX}")
 message   ("\nNow type 'make', followed by 'make install' as root.\n")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,14 @@
-# project(qjackctl)
-
-set(CMAKE_INCLUDE_CURRENT_DIR ON)
-
-set(CMAKE_AUTOUIC ON)
-set(CMAKE_AUTOMOC ON)
-set(CMAKE_AUTORCC ON)
+# project (qjackctl)
+
+set (CMAKE_INCLUDE_CURRENT_DIR ON)
+
+set (CMAKE_AUTOUIC ON)
+set (CMAKE_AUTOMOC ON)
+set (CMAKE_AUTORCC ON)
 
 if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
-    file(REMOVE ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
-endif()
+    file (REMOVE ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
+endif ()
 configure_file (cmake_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
 
 set (HEADERS
@@ -139,6 +139,12 @@
   ${RESOURCES}
 )
 
+# Add some debugger flags.
+if (CONFIG_DEBUG AND UNIX AND NOT APPLE)
+  target_compile_options (${PROJECT_NAME} PRIVATE -g -fsanitize=address -fno-omit-frame-pointer)
+  target_link_libraries (${PROJECT_NAME} PRIVATE asan)
+endif ()
+
 set_target_properties (${PROJECT_NAME} PROPERTIES CXX_STANDARD 17)
 
 if (WIN32)

=== debian/changelog ===
qjackctl (0.9.4-1~mx21+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Tue, 05 Oct 2021 00:51:54 -0400

qjackctl (0.9.4-1) unstable; urgency=medium

  * New upstream version 0.9.4
  * Bump Standards-Version to 4.6.0
  * Build with cmake
  * Add qttools5-dev to B-D
  * d/rules: Export QT_SELECT=qt5
  * Atm debian archive has no qt6, we compile with --disable-qt6
  * Drop spelling error patch, applied by upstream

 -- Dennis Braun <d_braun@kabelmail.de>  Mon, 23 Aug 2021 21:41:59 +0200

## qjackctl 0.9.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,11 @@
 cmake_minimum_required (VERSION 3.13)
 
 project (qjackctl
-  VERSION 0.9.4
+  VERSION 0.9.5
   DESCRIPTION "JACK Audio Connection Kit Qt GUI Interface"
   LANGUAGES C CXX)
+
+list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")
 
 set (CONFIG_VERSION ${PROJECT_VERSION})
 execute_process (
@@ -94,6 +96,9 @@
 # Enable PortAudio argument option.
 option (CONFIG_PORTAUDIO "Enable PortAudio interface (default=yes)" 1)
 
+# Enable CoreAudio argument option.
+option (CONFIG_COREAUDIO "Enable CoreAudio interface (default=yes)" 1)
+
 # Enable D-Bus argument option.
 option (CONFIG_DBUS "Enable D-Bus interface (default=yes)" 1)
 
@@ -106,6 +111,9 @@
 
 # Enable Qt6 build preference.
 option (CONFIG_QT6 "Enable Qt6 build (default=yes)" 1)
+
+# Enable install QT DLLs for Windows targets using windeployqt.
+option (CONFIG_INSTALL_QT "Install Qt for MacOS and Windows targets (default=no)" 0)
 
 
 # Fix for new CMAKE_REQUIRED_LIBRARIES policy.
@@ -130,11 +138,19 @@
 find_package (Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui Widgets Xml)
 
 if (CONFIG_XUNIQUE)
-  find_package (Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Network)
+  find_package (Qt${QT_VERSION_MAJOR} COMPONENTS Network)
+  if (NOT Qt${QT_VERSION_MAJOR}Network_FOUND)
+    message (WARNING "*** QT Network library not found.")
+    set (CONFIG_XUNIQUE 0)
+  endif ()
 endif ()
 
 if (CONFIG_DBUS)
-  find_package (Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS DBus)
+  find_package (Qt${QT_VERSION_MAJOR} COMPONENTS DBus)
+  if (NOT Qt${QT_VERSION_MAJOR}DBus_FOUND)
+    message (WARNING "*** QT DBus library not found.")
+    set (CONFIG_DBUS 0)
+  endif ()
 endif ()
 
 find_package (Qt${QT_VERSION_MAJOR}LinguistTools)
@@ -142,8 +158,8 @@
 include (CheckIncludeFile)
 include (CheckIncludeFiles)
 include (CheckIncludeFileCXX)
-include (CheckFunctionExists)
 include (CheckLibraryExists)
+include (CheckSymbolExists)
 
 # Checks for header files.
 if (UNIX AND NOT APPLE)
@@ -152,82 +168,78 @@
 
 
 # Find package modules
-include (FindPkgConfig)
-
-# Check for JACK libraries.
-pkg_check_modules (JACK REQUIRED IMPORTED_TARGET jack>=0.100.0)
-if (JACK_FOUND)
-  find_library(JACK_LIBRARY NAMES ${JACK_LIBRARIES} HINTS ${JACK_LIBDIR})
-endif ()
-if (JACK_LIBRARY)
-  set (CONFIG_JACK 1)
-  set (CMAKE_REQUIRED_LIBRARIES "${JACK_LIBRARY};${CMAKE_REQUIRED_LIBRARIES}")
-  # Check for jack/statistics.h header.
-  check_include_file (jack/statistics.h HAVE_JACK_STATISTICS_H)
-  if (NOT HAVE_JACK_STATISTICS_H)
-    set (CONFIG_JACK_STATISTICS 0)
-  else ()
-    set (CONFIG_JACK_STATISTICS 1)
-  endif ()
-  # Check for JACK MIDI headers availability.
-  if (CONFIG_JACK_MIDI)
-    check_include_file (jack/midiport.h HAVE_JACK_MIDIPORT_H)
-    if (NOT HAVE_JACK_MIDIPORT_H)
-      set (CONFIG_JACK_MIDI 0)
-    endif ()
-  endif ()
-  # Check for JACK session headers availability.
-  if (CONFIG_JACK_SESSION)
-    check_include_file (jack/session.h HAVE_JACK_SESSION_H)
-    if (NOT HAVE_JACK_SESSION_H)
-      set (CONFIG_JACK_SESSION 0)
-    endif ()
-  endif ()
-  # Check for JACK metadata headers availability.
-  if (CONFIG_JACK_METADATA)
-    check_include_file (jack/metadata.h HAVE_JACK_METADATA_H)
-    if (NOT HAVE_JACK_METADATA_H)
-      set (CONFIG_JACK_METADATA 0)
-    endif ()
-  endif ()
-  if (NOT CONFIG_JACK_METADATA)
-      set (CONFIG_JACK_CV  0)
-      set (CONFIG_JACK_OSC 0)
-  endif ()
-  # Check for jack_transport_query function.
-  check_function_exists (jack_transport_query CONFIG_JACK_TRANSPORT)
-  # Check for jack_is_realtime function.
-  check_function_exists (jack_is_realtime CONFIG_JACK_REALTIME)
-  # Check for jack_get_xrun_delayed_usecs function.
-  check_function_exists (jack_get_xrun_delayed_usecs CONFIG_JACK_XRUN_DELAY)
-  # Check for jack_get_max_delayed_usecs function.
-  check_function_exists (jack_get_max_delayed_usecs CONFIG_JACK_MAX_DELAY)
-  # Check for jack_set_port_rename_callback
-  check_function_exists (jack_set_port_rename_callback CONFIG_JACK_PORT_RENAME)
-  # Check for jack_port_get_aliases function.
-  if (CONFIG_JACK_PORT_ALIASES)
-    check_function_exists (jack_port_get_aliases CONFIG_JACK_PORT_ALIASES)
-  endif ()
-  # Check for jack_get_version_string function.
-  if (CONFIG_JACK_VERSION)
-    check_function_exists (jack_get_version_string CONFIG_JACK_VERSION)
-  endif ()
-  # Check for jack_free function.
-  check_function_exists (jack_free CONFIG_JACK_FREE)
-else ()
-  message (FATAL_ERROR "*** JACK library not found.")
-  set (CONFIG_JACK 0)
+find_package (Jack REQUIRED)
+set (CONFIG_JACK 1)
+set (CMAKE_REQUIRED_LIBRARIES "${Jack_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
+set (CMAKE_REQUIRED_INCLUDES "${Jack_INCLUDE_DIRS};${CMAKE_REQUIRED_INCLUDES}")
+# Check for jack/statistics.h header.
+check_include_file (jack/statistics.h HAVE_JACK_STATISTICS_H)
+if (NOT HAVE_JACK_STATISTICS_H)
+  set (CONFIG_JACK_STATISTICS 0)
+else ()
+  set (CONFIG_JACK_STATISTICS 1)
+endif ()
+# Check for JACK MIDI headers availability.
+if (CONFIG_JACK_MIDI)
+  check_include_file (jack/midiport.h HAVE_JACK_MIDIPORT_H)
+  if (NOT HAVE_JACK_MIDIPORT_H)
+    set (CONFIG_JACK_MIDI 0)
+  endif ()
+endif ()
+# Check for JACK session headers availability.
+if (CONFIG_JACK_SESSION)
+  check_include_file (jack/session.h HAVE_JACK_SESSION_H)
+  if (NOT HAVE_JACK_SESSION_H)
+    set (CONFIG_JACK_SESSION 0)
+  endif ()
+endif ()
+# Check for JACK metadata headers availability.
+if (CONFIG_JACK_METADATA)
+  check_include_file (jack/metadata.h HAVE_JACK_METADATA_H)
+  if (NOT HAVE_JACK_METADATA_H)
+    set (CONFIG_JACK_METADATA 0)
+  endif ()
+endif ()
+if (NOT CONFIG_JACK_METADATA)
+  set (CONFIG_JACK_CV  0)
+  set (CONFIG_JACK_OSC 0)
+endif ()
+# Check for jack_is_realtime function.
+check_symbol_exists (jack_is_realtime "jack/jack.h" CONFIG_JACK_REALTIME)
+# Check for jack_free function.
+check_symbol_exists (jack_free "jack/jack.h" CONFIG_JACK_FREE)
+# Check for jack_set_port_rename_callback
+check_symbol_exists (jack_set_port_rename_callback "jack/jack.h" CONFIG_JACK_PORT_RENAME)
+# Check for jack_transport_query function.
+check_symbol_exists (jack_transport_query "jack/transport.h" CONFIG_JACK_TRANSPORT)
+# Check for jack_get_xrun_delayed_usecs function.
+check_symbol_exists (jack_get_xrun_delayed_usecs "jack/statistics.h" CONFIG_JACK_XRUN_DELAY)
+# Check for jack_get_max_delayed_usecs function.
+check_symbol_exists (jack_get_max_delayed_usecs "jack/statistics.h" CONFIG_JACK_MAX_DELAY)
+
+# Check for jack_port_get_aliases function.
+if (CONFIG_JACK_PORT_ALIASES)
+  check_symbol_exists (jack_port_get_aliases "jack/jack.h" HAVE_JACK_PORT_ALIASES)
+  if (NOT HAVE_JACK_PORT_ALIASES)
+    set (CONFIG_JACK_PORT_ALIASES 0)
+  endif ()
+endif ()
+
+# Check for jack_get_version_string function.
+if (CONFIG_JACK_VERSION)
+  check_symbol_exists (jack_get_version_string "jack/jack.h" HAVE_JACK_VERSION)
+  if (NOT HAVE_JACK_VERSION)
+    set (CONFIG_JACK_VERSION 0)
+  endif ()
 endif ()
 
 # Check for ALSA libraries.
 if (CONFIG_ALSA_SEQ)
-  pkg_check_modules (ALSA IMPORTED_TARGET alsa)
+  find_package (ALSA)
   if (ALSA_FOUND)
-    find_library(ALSA_LIBRARY NAMES ${ALSA_LIBRARIES} HINTS ${ALSA_LIBDIR})
-  endif ()
-  if (ALSA_LIBRARY)
     set (CONFIG_ALSA_SEQ 1)
-    set (CMAKE_REQUIRED_LIBRARIES "${ALSA_LIBRARY};${CMAKE_REQUIRED_LIBRARIES}")
+    set (CMAKE_REQUIRED_LIBRARIES "${ALSA_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
+    set (CMAKE_REQUIRED_INCLUDES "${ALSA_INCLUDE_DIRS};${CMAKE_REQUIRED_INCLUDES}")
   else ()
     message (WARNING "*** ALSA library not found.")
     set (CONFIG_ALSA_SEQ 0)
@@ -236,11 +248,8 @@
 
 # Check for PORTAUDIO libraries.
 if (CONFIG_PORTAUDIO)
-  pkg_check_modules (PORTAUDIO IMPORTED_TARGET portaudio-2.0)
-  if (PORTAUDIO_FOUND)
-    find_library(PORTAUDIO_LIBRARY NAMES ${PORTAUDIO_LIBRARIES} HINTS ${PORTAUDIO_LIBDIR})
-  endif ()
-  if (PORTAUDIO_LIBRARY)
+  find_package (PortAudio)
+  if (PortAudio_FOUND)
     set (CONFIG_PORTAUDIO 1)
    #set (CMAKE_REQUIRED_LIBRARIES "${PORTAUDIO_LIBRARY};${CMAKE_REQUIRED_LIBRARIES}")
   else ()
@@ -250,9 +259,13 @@
 endif ()
 
 
-if (APPLE AND CONFIG_COREAUDIO)
-  check_include_file (CoreAudio/CoreAudio.h HAVE_COREAUDIO_H)
-  if (NOT HAVE_COREAUDIO_H)
+if (CONFIG_COREAUDIO)
+  if (APPLE)
+    check_include_file ("CoreAudio/CoreAudio.h" HAVE_COREAUDIO_H)
+    find_library(CORE_FOUNDATION_LIBRARY CoreFoundation)
+    find_library(CORE_AUDIO_LIBRARY CoreAudio)
+  endif ()
+  if (NOT APPLE OR NOT HAVE_COREAUDIO_H OR NOT CORE_FOUNDATION_LIBRARY OR NOT CORE_AUDIO_LIBRARY)
     set (CONFIG_COREAUDIO 0)
   endif ()
 endif ()
@@ -260,10 +273,20 @@
 
 add_subdirectory (src)
 
-configure_file (qjackctl.spec.in qjackctl.spec IMMEDIATE @ONLY)
-
-install (FILES qjackctl.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
-install (FILES qjackctl.fr.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/fr/man1 RENAME qjackctl.1)
+if (NOT WIN32)
+  configure_file (qjackctl.spec.in qjackctl.spec IMMEDIATE @ONLY)
+
+  install (FILES qjackctl.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
+  install (FILES qjackctl.fr.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/fr/man1 RENAME qjackctl.1)
+endif ()
+
+if (WIN32)
+  set(CPACK_GENERATOR ZIP)
+else ()
+  set(CPACK_GENERATOR TGZ)
+endif ()
+
+include(CPack)
 
 # Configuration status
 macro (SHOW_OPTION text value)
@@ -298,5 +321,7 @@
 show_option ("  System tray icon support . . . . . . . . . . . . ." CONFIG_SYSTEM_TRAY)
 show_option ("  Unique/Single instance support . . . . . . . . . ." CONFIG_XUNIQUE)
 show_option ("  Debugger stack-trace (gdb) . . . . . . . . . . . ." CONFIG_STACKTRACE)
+show_option ("  Install Qt on MacOS / Windows  . . . . . . . . . ." CONFIG_INSTALL_QT)
 message   ("\n  Install prefix . . . . . . . . . . . . . . . . . .: ${CONFIG_PREFIX}")
 message   ("\nNow type 'make', followed by 'make install' as root.\n")
+

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 set (CMAKE_AUTORCC ON)
 
 if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
-    file (REMOVE ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
+  file (REMOVE ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
 endif ()
 configure_file (cmake_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
 
@@ -95,6 +95,7 @@
 	translations/qjackctl_fr.ts
 	translations/qjackctl_it.ts
 	translations/qjackctl_ja.ts
+	translations/qjackctl_ko.ts
 	translations/qjackctl_nl.ts
 	translations/qjackctl_pt.ts
 	translations/qjackctl_ru.ts
@@ -110,28 +111,6 @@
 
 add_custom_target (translations ALL DEPENDS ${QM_FILES})
 
-if (WIN32)
-  set (RC_FILE ${CMAKE_CURRENT_SOURCE_DIR}/win32/${PROJECT_NAME}.rc)
-  set (RES_FILE ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.res.obj)
-  find_program (WINDRES_EXECUTABLE NAMES windres mingw32-windres i686-mingw32-windres)
-  if (MINGW)
-    exec_program (${WINDRES_EXECUTABLE}
-      ARGS "-i ${RC_FILE} -o ${RES_FILE} --include-dir=${CMAKE_CURRENT_SOURCE_DIR}/images")
-    list (APPEND SOURCES ${RES_FILE})
-  else ()
-    list (APPEND SOURCES ${RC_FILE})
-  endif ()
-endif ()
-
-if (APPLE)
-  set (ICON_FILE ${CMAKE_CURRENT_SOURCE_DIR}/images/${PROJECT_NAME}.icns)
-  list (APPEND SOURCES ${ICON_FILE})
-  set (MACOSX_BUNDLE_ICON_FILE ${PROJECT_NAME}.icns)
-  set_source_files_properties (${ICON_FILE} PROPERTIES
-    MACOSX_PACKAGE_LOCATION Resources)
-endif ()
-
-
 add_executable (${PROJECT_NAME}
   ${HEADERS}
   ${SOURCES}
@@ -149,6 +128,7 @@
 
 if (WIN32)
   set_target_properties (${PROJECT_NAME} PROPERTIES WIN32_EXECUTABLE true)
+  target_compile_definitions (${PROJECT_NAME} PUBLIC _USE_MATH_DEFINES)
 endif ()
 
 if (APPLE)
@@ -166,15 +146,19 @@
 endif ()
 
 if (CONFIG_JACK)
-  target_link_libraries (${PROJECT_NAME} PRIVATE PkgConfig::JACK)
+  target_link_libraries (${PROJECT_NAME} PRIVATE Jack::Jack)
 endif ()
 
 if (CONFIG_ALSA_SEQ)
-  target_link_libraries (${PROJECT_NAME} PRIVATE PkgConfig::ALSA)
+  target_link_libraries (${PROJECT_NAME} PRIVATE ALSA::ALSA)
 endif ()
 
 if (CONFIG_PORTAUDIO)
-  target_link_libraries (${PROJECT_NAME} PRIVATE PkgConfig::PORTAUDIO)
+  target_link_libraries (${PROJECT_NAME} PRIVATE PortAudio::PortAudio)
+endif ()
+
+if (CONFIG_COREAUDIO)
+  target_link_libraries (${PROJECT_NAME} PRIVATE ${CORE_FOUNDATION_LIBRARY} ${CORE_AUDIO_LIBRARY})
 endif ()
 
 
@@ -191,12 +175,74 @@
      DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
   install (FILES appdata/${PROJECT_NAME}.appdata.xml
      DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)
-endif ()
-
-if (WIN32)
-   install (TARGETS ${PROJECT_NAME} RUNTIME
-     DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
-   install (FILES ${QM_FILES}
-     DESTINATION ${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME}/translations)
-endif ()
-
+elseif (APPLE)
+  # Generate bundle on MacOS with QjackCtl.icns as the icon and a custom Info.plist file.
+  target_sources(${PROJECT_NAME} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/images/QjackCtl.icns)
+  set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/images/QjackCtl.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
+  set_target_properties(${PROJECT_NAME} PROPERTIES
+    MACOSX_BUNDLE True
+    OUTPUT_NAME QjackCtl
+    MACOSX_RPATH ON
+    INSTALL_RPATH @executable_path/../Frameworks
+    MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/appdata/Info.plist
+  )
+  install (TARGETS ${PROJECT_NAME} BUNDLE
+     DESTINATION ${CMAKE_INSTALL_BINDIR})
+elseif (WIN32)
+  install (TARGETS ${PROJECT_NAME} RUNTIME
+     DESTINATION .)
+  # Use same path as windeployqt for translations
+  install (FILES ${QM_FILES}
+     DESTINATION translations)
+endif ()
+
+
+if (WIN32 AND CONFIG_INSTALL_QT)
+  get_target_property (_qt_qmake_location Qt${QT_VERSION_MAJOR}::qmake IMPORTED_LOCATION)
+  get_filename_component (_qt_bin_dir "${_qt_qmake_location}" DIRECTORY)
+  set (QT_WINDEPLOYQT "${_qt_bin_dir}/windeployqt.exe")
+
+  if (EXISTS ${QT_WINDEPLOYQT})
+    # execute windeployqt in a tmp directory after build
+    if (QT_VERSION_MAJOR MATCHES "5")
+      # These options are not available with Qt6
+      set (WINDEPLOYQT_EXTRA_OPTIONS --no-webkit2 --no-angle)
+    endif ()
+
+    add_custom_command (TARGET ${PROJECT_NAME}
+      POST_BUILD
+      COMMAND ${CMAKE_COMMAND} -E remove_directory "${CMAKE_CURRENT_BINARY_DIR}/windeployqt"
+      COMMAND set PATH=${_qt_bin_dir}$<SEMICOLON>%PATH%
+      COMMAND "${QT_WINDEPLOYQT}"
+        --dir "${CMAKE_CURRENT_BINARY_DIR}/windeployqt"
+        --no-quick-import
+        --no-opengl-sw
+        --no-virtualkeyboard
+        --no-svg
+        ${WINDEPLOYQT_EXTRA_OPTIONS}
+        "$<TARGET_FILE:${PROJECT_NAME}>"
+      USES_TERMINAL
+    )
+
+    # copy deployment directory during installation
+    install (
+      DIRECTORY
+      "${CMAKE_CURRENT_BINARY_DIR}/windeployqt/"
+      DESTINATION .
+    )
+  endif ()
+endif ()
+
+if (APPLE AND CONFIG_INSTALL_QT)
+  get_target_property (_qt_qmake_location Qt${QT_VERSION_MAJOR}::qmake IMPORTED_LOCATION)
+  get_filename_component (_qt_bin_dir "${_qt_qmake_location}" DIRECTORY)
+  find_program(QT_MACDEPLOYQT macdeployqt HINTS "${_qt_bin_dir}")
+
+  if (EXISTS ${QT_MACDEPLOYQT})
+    add_custom_command (TARGET ${PROJECT_NAME}
+      POST_BUILD
+      COMMAND "${QT_MACDEPLOYQT}" "$<TARGET_FILE_DIR:${PROJECT_NAME}>/../.."
+      USES_TERMINAL
+    )
+  endif ()
+endif ()

=== debian/changelog ===
qjackctl (0.9.5-1~mx21+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Mon, 22 Nov 2021 11:31:10 -0500

qjackctl (0.9.5-1) unstable; urgency=medium

  * New upstream version 0.9.5

 -- Dennis Braun <d_braun@kabelmail.de>  Sun, 10 Oct 2021 21:36:08 +0200

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export QT_SELECT=qt5

%:
	dh $@ -Scmake --disable-qt6

override_dh_clean:
	dh_clean --exclude=qjackctl.pro

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## qjackctl 0.9.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
-cmake_minimum_required (VERSION 3.13)
+cmake_minimum_required (VERSION 3.15)
 
 project (qjackctl
-  VERSION 0.9.5
+  VERSION 0.9.6
   DESCRIPTION "JACK Audio Connection Kit Qt GUI Interface"
   LANGUAGES C CXX)
 
@@ -322,6 +322,5 @@
 show_option ("  Unique/Single instance support . . . . . . . . . ." CONFIG_XUNIQUE)
 show_option ("  Debugger stack-trace (gdb) . . . . . . . . . . . ." CONFIG_STACKTRACE)
 show_option ("  Install Qt on MacOS / Windows  . . . . . . . . . ." CONFIG_INSTALL_QT)
-message   ("\n  Install prefix . . . . . . . . . . . . . . . . . .: ${CONFIG_PREFIX}")
-message   ("\nNow type 'make', followed by 'make install' as root.\n")
-
+message   ("\n  Install prefix . . . . . . . . . . . . . . . . . .: ${CONFIG_PREFIX}\n")
+

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
   file (REMOVE ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
 endif ()
-configure_file (cmake_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
+configure_file (config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
 
 set (HEADERS
   qjackctl.h
@@ -167,13 +167,13 @@
      DESTINATION ${CMAKE_INSTALL_BINDIR})
   install (FILES ${QM_FILES}
      DESTINATION ${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME}/translations)
-  install (FILES ${PROJECT_NAME}.desktop
+  install (FILES org.rncbc.${PROJECT_NAME}.desktop
      DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
   install (FILES images/${PROJECT_NAME}.png
      DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/32x32/apps)
   install (FILES images/${PROJECT_NAME}.svg
      DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
-  install (FILES appdata/${PROJECT_NAME}.appdata.xml
+  install (FILES appdata/org.rncbc.${PROJECT_NAME}.xml
      DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)
 elseif (APPLE)
   # Generate bundle on MacOS with QjackCtl.icns as the icon and a custom Info.plist file.

=== debian/changelog ===
qjackctl (0.9.6-1) unstable; urgency=medium

  * New upstream version 0.9.6
  * Remove hardening patch, autotools build system has been removed
  * d/copyright: Appdata file has been renamed
  * Update d/copyright years
  * Update d/lintian-overrides

 -- Dennis Braun <d_braun@kabelmail.de>  Thu, 13 Jan 2022 16:07:03 +0100

=== debian/control ===
--- 
+++ 
@@ -8,14 +8,16 @@
  Jaromír Mikeš <mira.mikes@seznam.cz>,
  Free Ekanayaka <freee@debian.org>
 Build-Depends:
+ cmake,
  debhelper-compat (= 13),
  libasound2-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386],
  libjack-dev,
  qtbase5-dev,
+ qttools5-dev,
  qttools5-dev-tools,
  libqt5x11extras5-dev,
  libx11-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://qjackctl.sourceforge.io
 Vcs-Git: https://salsa.debian.org/multimedia-team/qjackctl.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/qjackctl

=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,3 @@
 
 override_dh_clean:
 	dh_clean --exclude=qjackctl.pro
-
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym

=== debian/watch ===
version=4
https://sf.net/qjackctl/qjackctl-(.+)\.tar\.gz
